using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Purchase.PurchaseOrder.Cqrs;

public record DeletePurchaseOrderByIdCommand(string Id) : IRequest<bool>;

public class DeletePurchaseOrderByIdHandler : IRequestHandler<DeletePurchaseOrderByIdCommand, bool>
{
    private readonly AppDbContext _context;
    public DeletePurchaseOrderByIdHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeletePurchaseOrderByIdCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.PurchaseOrder
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null) return false;

        _context.PurchaseOrder.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);
        return true;
    }
}